

#include <stdio.h>
#include <stdlib.h>
#include <ap_int.h>
#include <ap_utils.h>
#include <hls_stream.h>

enum {
	UI1_MINUS07071=0,
	UI1_PLUS07071
};

enum {
	I3_ZERO=0,
	I3_ONE,
	I3_07071,
	I3_05,
};

typedef struct {
	ap_uint<1> real;
	ap_uint<1> imag;
} cuint1;

typedef struct {
	ap_uint<2> data;
//	cuint1 data;
	ap_uint<1> dest;
	ap_uint<1> last;
} cplxui1stream;

typedef struct {
	ap_int<3> real;
	ap_int<3> imag;
} cint3;

#ifdef DEBUG1
typedef struct {
	ap_int<3> real;
	ap_int<3> imag;
	ap_int<3> real_phase;
	ap_int<3> imag_phase;
	ap_int<3> real_in3;
	ap_int<3> imag_in3;
	ap_uint<1> real_in;
	ap_uint<1> imag_in;
} cint3out;

typedef struct {
	cint3out	   data;
	ap_uint<1> dest;
	ap_uint<1> last;
} cplxi3stream;
#else
typedef struct {
//	cint3	   data;
	ap_uint<6> data;
	ap_uint<1> dest;
	ap_uint<1> last;
} cplxi3stream;
#endif

static const cint3 diff_mod_in_phase_ref[1536] = {
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{0,1}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {1,0}, {1,0}, {0,-1}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,-1}, {-1,0}, {1,0}, {0,-1},
{0,1}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {1,0}, {1,0}, {0,-1}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,-1}, {-1,0}, {1,0}, {0,-1},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {1,0}, {0,-1}, {1,0}, {0,1}, {-1,0}, {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,-1}, {1,0}, {1,0}, {0,1},
{0,1}, {1,0}, {0,-1}, {1,0}, {0,1}, {-1,0}, {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,-1}, {1,0}, {1,0}, {0,1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{1,0}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,1}, {0,-1}, {1,0}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {-1,0}, {0,-1}, {0,-1}, {1,0},
{1,0}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,1}, {0,-1}, {1,0}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {-1,0}, {0,-1}, {0,-1}, {1,0},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{0,-1}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,1}, {1,0}, {-1,0}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,1}, {0,-1}, {1,0}, {-1,0},
{0,-1}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,1}, {1,0}, {-1,0}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,1}, {0,-1}, {1,0}, {-1,0},
{0,-1}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {1,0}, {-1,0}, {0,-1}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,1}, {-1,0}, {-1,0}, {0,-1},
{0,-1}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {1,0}, {-1,0}, {0,-1}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,1}, {-1,0}, {-1,0}, {0,-1},
{1,0}, {-1,0}, {1,0}, {1,0}, {1,0}, {1,0}, {0,1}, {0,1}, {-1,0}, {1,0}, {1,0}, {1,0}, {-1,0}, {-1,0}, {0,1}, {0,1},
{1,0}, {-1,0}, {1,0}, {1,0}, {1,0}, {1,0}, {0,1}, {0,1}, {-1,0}, {1,0}, {1,0}, {1,0}, {-1,0}, {-1,0}, {0,1}, {0,1},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,-1}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {1,0}, {-1,0}, {0,-1}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,1}, {-1,0}, {-1,0}, {0,-1},
{0,-1}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {1,0}, {-1,0}, {0,-1}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,1}, {-1,0}, {-1,0}, {0,-1},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{0,-1}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,1}, {1,0}, {-1,0}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,1}, {0,-1}, {1,0}, {-1,0},
{0,-1}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,1}, {1,0}, {-1,0}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,1}, {0,-1}, {1,0}, {-1,0},
{1,0}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,1}, {0,-1}, {1,0}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {-1,0}, {0,-1}, {0,-1}, {1,0},
{1,0}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,1}, {0,-1}, {1,0}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {-1,0}, {0,-1}, {0,-1}, {1,0},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{1,0}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,-1}, {0,-1}, {-1,0}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {-1,0}, {0,1}, {0,-1}, {-1,0},
{1,0}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,-1}, {0,-1}, {-1,0}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {-1,0}, {0,1}, {0,-1}, {-1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {1,0}, {0,-1}, {1,0}, {0,1}, {-1,0}, {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,-1}, {1,0}, {1,0}, {0,1},
{0,1}, {1,0}, {0,-1}, {1,0}, {0,1}, {-1,0}, {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,-1}, {1,0}, {1,0}, {0,1},
{0,1}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,1}, {-1,0}, {-1,0}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,-1}, {0,-1}, {-1,0}, {-1,0},
{0,1}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,1}, {-1,0}, {-1,0}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,-1}, {0,-1}, {-1,0}, {-1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{1,0}, {1,0}, {1,0}, {-1,0}, {1,0}, {-1,0}, {0,1}, {0,-1}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {-1,0}, {1,0}, {0,1}, {0,-1},
{1,0}, {1,0}, {1,0}, {-1,0}, {1,0}, {-1,0}, {0,1}, {0,-1}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {-1,0}, {1,0}, {0,1}, {0,-1},
{0,1}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {1,0}, {1,0}, {0,-1}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,-1}, {-1,0}, {1,0}, {0,-1},
{0,1}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {1,0}, {1,0}, {0,-1}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,-1}, {-1,0}, {1,0}, {0,-1},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{0,-1}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,-1}, {1,0}, {1,0}, {0,1}, {0,-1}, {0,-1}, {0,-1}, {0,1}, {0,1}, {1,0}, {1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{-1,0}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {1,0}, {0,-1}, {0,1}, {1,0}, {1,0}, {-1,0}, {1,0}, {1,0}, {-1,0}, {0,-1}, {0,1},
{-1,0}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {1,0}, {0,-1}, {0,1}, {1,0}, {1,0}, {-1,0}, {1,0}, {1,0}, {-1,0}, {0,-1}, {0,1},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{0,1}, {1,0}, {0,-1}, {1,0}, {0,1}, {-1,0}, {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,-1}, {1,0}, {1,0}, {0,1},
{0,1}, {1,0}, {0,-1}, {1,0}, {0,1}, {-1,0}, {1,0}, {0,1}, {0,-1}, {-1,0}, {0,-1}, {1,0}, {0,-1}, {1,0}, {1,0}, {0,1},
{-1,0}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {1,0}, {0,-1}, {0,1}, {1,0}, {1,0}, {-1,0}, {1,0}, {1,0}, {-1,0}, {0,-1}, {0,1},
{-1,0}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {1,0}, {0,-1}, {0,1}, {1,0}, {1,0}, {-1,0}, {1,0}, {1,0}, {-1,0}, {0,-1}, {0,1},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{0,1}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,1}, {-1,0}, {-1,0}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,-1}, {0,-1}, {-1,0}, {-1,0},
{0,1}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,1}, {-1,0}, {-1,0}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,-1}, {0,-1}, {-1,0}, {-1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{0,-1}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,1}, {1,0}, {-1,0}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,1}, {0,-1}, {1,0}, {-1,0},
{0,-1}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,1}, {1,0}, {-1,0}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,1}, {0,-1}, {1,0}, {-1,0},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{0,-1}, {1,0}, {0,1}, {1,0}, {0,-1}, {-1,0}, {-1,0}, {0,1}, {0,1}, {-1,0}, {0,1}, {1,0}, {0,1}, {1,0}, {-1,0}, {0,1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {-1,0}, {0,-1}, {0,-1}, {1,0}, {-1,0}, {-1,0}, {-1,0}, {1,0}, {1,0}, {0,-1}, {0,-1},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{-1,0}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,-1}, {0,1}, {-1,0}, {1,0}, {0,-1}, {1,0}, {0,1}, {1,0}, {0,1}, {0,1}, {-1,0},
{-1,0}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {1,0}, {0,-1}, {0,1}, {1,0}, {1,0}, {-1,0}, {1,0}, {1,0}, {-1,0}, {0,-1}, {0,1},
{-1,0}, {-1,0}, {-1,0}, {1,0}, {-1,0}, {1,0}, {0,-1}, {0,1}, {1,0}, {1,0}, {-1,0}, {1,0}, {1,0}, {-1,0}, {0,-1}, {0,1},
{0,1}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {1,0}, {1,0}, {0,-1}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,-1}, {-1,0}, {1,0}, {0,-1},
{0,1}, {-1,0}, {0,-1}, {-1,0}, {0,1}, {1,0}, {1,0}, {0,-1}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,-1}, {-1,0}, {1,0}, {0,-1},
{0,1}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,1}, {-1,0}, {-1,0}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,-1}, {0,-1}, {-1,0}, {-1,0},
{0,1}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,1}, {-1,0}, {-1,0}, {0,-1}, {0,1}, {0,1}, {0,1}, {0,-1}, {0,-1}, {-1,0}, {-1,0},
{0,-1}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {1,0}, {-1,0}, {0,-1}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,1}, {-1,0}, {-1,0}, {0,-1},
{0,-1}, {-1,0}, {0,1}, {-1,0}, {0,-1}, {1,0}, {-1,0}, {0,-1}, {0,1}, {1,0}, {0,1}, {-1,0}, {0,1}, {-1,0}, {-1,0}, {0,-1},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{0,1}, {0,1}, {0,1}, {0,-1}, {0,1}, {0,-1}, {-1,0}, {1,0}, {0,-1}, {0,-1}, {0,1}, {0,-1}, {0,-1}, {0,1}, {-1,0}, {1,0},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0},
{-1,0}, {0,-1}, {1,0}, {0,-1}, {-1,0}, {0,1}, {0,1}, {1,0}, {1,0}, {0,1}, {1,0}, {0,-1}, {1,0}, {0,-1}, {0,1}, {1,0}
};

cint3 qpsk_sym1to3(cuint1 in)
{
	cint3 out;

	if(in.real==UI1_MINUS07071){
		out.real = -I3_07071;
	} else {
		out.real = I3_07071;
	}

	if(in.imag==UI1_MINUS07071){
		out.imag = -I3_07071;
	} else {
		out.imag = I3_07071;
	}
	return out;
}

ap_int<3> add3x3(ap_int<3> a, ap_int<3> b)
{
	/* add zero */
	if(a == I3_ZERO)
		return b;
	if(b == I3_ZERO)
		return a;
	if(a == I3_05 && b == I3_05 )
		return I3_ONE;
	if(a == -I3_05 && b == -I3_05 )
		return -I3_ONE;
	/* self-destroy */
	if(a == -b)
		return I3_ZERO;
	return I3_ZERO;
}

ap_int<3> mul3x3pos(ap_int<3> a, ap_int<3> b)
{
	/* x*1 = x */
	if(a==I3_ONE)
		return b;
	if(b==I3_ONE)
		return a;

	/* 1,41 * 0,7071 == 1 */
	if(a==I3_07071 && b==I3_07071)
		return I3_05;

	/* x*0 = 0 */
	return I3_ZERO;
}

ap_int<3> mul3x3(ap_int<3> a, ap_int<3> b)
{
	if(a<0 && b<0)
		return mul3x3pos(-a, -b);
	if(a>=0 && b>=0)
		return mul3x3pos(a, b);
	if(a>=0)
		return -mul3x3pos(a, -b);
	return -mul3x3pos(-a, b);
}



/**************************************************
 * Complex Numbers
 **************************************************
 * (a + bi) * (c + di) = (ac - bd) + (ad + bc)i
 * */

#ifdef DEBUG1
cint3 cmul3x3(cint3 x, cint3 y, bool dbg)
#else
cint3 cmul3x3(cint3 x, cint3 y)
#endif
{
	cint3 z;
	//-1
	z.real = add3x3(mul3x3(x.real, y.real), -mul3x3(x.imag, y.imag));
	z.imag = add3x3(mul3x3(x.real, y.imag), mul3x3(x.imag, y.real));
#ifdef DEBUG1
	if(dbg) {
		fprintf(stderr, "cmul3x3 out:(%d + %di) * in:(%d + %di) = (%d + %di)\n", (int) x.real, (int) x.imag, (int) y.real, (int) y.imag,
				(int)z.real, (int)z.imag );

		fprintf(stderr, "r: mul3x3(%d, %d) = %d\n", (int) x.real, (int) y.real, (int) mul3x3(x.real, y.real) );
		fprintf(stderr, "i: mul3x3(%d, %d) = %d\n", (int) x.imag, (int) y.imag, (int) mul3x3(x.imag, y.imag) );
		fprintf(stderr, "add3x3(%d, %d) = %d\n", (int) mul3x3(x.real, y.real), (int) -mul3x3(x.imag, y.imag),  (int) add3x3(mul3x3(x.real, y.real), -mul3x3(x.imag, y.imag)));

	}
#endif
	return z;
}

static cint3 diff_mod_out_phase_buff[1536];

void dqpsk_modulator(hls::stream<cplxui1stream> &input, hls::stream<cplxi3stream> &output)
{
//#pragma HLS INTERFACE ap_fifo port=input
//#pragma HLS INTERFACE ap_fifo port=output
//#pragma HLS INTERFACE axis port=input
//#pragma HLS INTERFACE axis port=output
//#pragma HLS RESOURCE variable=input core=AXI4Stream
//#pragma HLS RESOURCE variable=output core=AXI4Stream
//#pragma HLS INTERFACE ap_ctrl_none port=return
#pragma HLS INTERFACE ap_fifo port=input
#pragma HLS INTERFACE ap_fifo port=output
#pragma HLS RESOURCE variable=input  core=AXIS metadata="-bus_bundle S_AXIS"
#pragma HLS RESOURCE variable=output core=AXIS metadata="-bus_bundle M_AXIS"
#pragma HLS INTERFACE ap_ctrl_none port=return

	ap_uint<12> i;
	//stream_in_data x;
	cplxi3stream y;
	cplxui1stream x;

	x = input.read(); //data=0 -> -0.7071, data=1 -> 0.7071
    if(x.dest) {
    	/* configure fft and reorder module */
		/* 1 or 1, pass next */
		if(x.data) {
			y.dest = 1;
			y.last = 1;
			y.data = x.data; //will be 0 or 1
			output.write(y);
		} else {
			y.dest = 0;
			/* send phase references */
			for(i=0;i<1536;i++){
#ifdef DEBUG1
				diff_mod_out_phase_buff[i].real = diff_mod_in_phase_ref[i].real;
				diff_mod_out_phase_buff[i].imag = diff_mod_in_phase_ref[i].imag;
				y.data.real = diff_mod_out_phase_buff[i].real;
				y.data.imag = diff_mod_out_phase_buff[i].imag;
				y.data.real_phase = 0;
				y.data.imag_phase = 0;
				y.data.real_in = 0;
				y.data.imag_in = 0;
				y.data.real_in3 = 0;
				y.data.imag_in3 = 0;
#else
				diff_mod_out_phase_buff[i] = diff_mod_in_phase_ref[i];
				y.data.set(0, diff_mod_out_phase_buff[i].real.bit(0));
				y.data.set(1, diff_mod_out_phase_buff[i].real.bit(1));
				y.data.set(2, diff_mod_out_phase_buff[i].real.bit(2));
				y.data.set(3, diff_mod_out_phase_buff[i].imag.bit(0));
				y.data.set(4, diff_mod_out_phase_buff[i].imag.bit(1));
				y.data.set(5, diff_mod_out_phase_buff[i].imag.bit(2));
				//y.data.concat() = .range(2, 0) = diff_mod_out_phase_buff[i].real;
				//y.data.range(5, 3) = diff_mod_out_phase_buff[i].imag;
				//= (ap_uint<6>) (((ap_uint<3>) diff_mod_out_phase_buff[i].imag) << 3 | ((ap_uint<3>) diff_mod_out_phase_buff[i].real));
#endif
				y.last = (i==1535) ? 1 : 0;
				output.write(y);
			}
		}
    } else {
		y.dest = 0;
    	for(i=0;i<1536;i++) {
    		if(i!=0)
    			x = input.read();
#ifdef DEBUG1
		diff_mod_out_phase_buff[i] = cmul3x3(diff_mod_out_phase_buff[i], qpsk_sym1to3(x.data), i==0);
		y.data.real_phase = diff_mod_out_phase_buff[i].real;
		y.data.imag_phase = diff_mod_out_phase_buff[i].imag;
		y.data.real_in = x.data.real;
		y.data.imag_in = x.data.imag;
		cint3 tmp = qpsk_sym1to3(x.data);
		y.data.real_in3 = tmp.real;
		y.data.imag_in3 = tmp.imag;
		diff_mod_out_phase_buff[i] = cmul3x3(diff_mod_out_phase_buff[i], qpsk_sym1to3(x.data));
#else
			cuint1 tmp;
			tmp.real = x.data.bit(0);
			tmp.imag = x.data.bit(1);
			diff_mod_out_phase_buff[i] = cmul3x3(diff_mod_out_phase_buff[i], qpsk_sym1to3(tmp));
			//y.data = diff_mod_out_phase_buff[i];
			y.data.set(0, diff_mod_out_phase_buff[i].real.bit(0));
			y.data.set(1, diff_mod_out_phase_buff[i].real.bit(1));
			y.data.set(2, diff_mod_out_phase_buff[i].real.bit(2));
			y.data.set(3, diff_mod_out_phase_buff[i].imag.bit(0));
			y.data.set(4, diff_mod_out_phase_buff[i].imag.bit(1));
			y.data.set(5, diff_mod_out_phase_buff[i].imag.bit(2));


			//memcpy(&y.data, &diff_mod_out_phase_buff[i], sizeof(cint3));
			//diff_mod_out_phase_buff[i] = cmul3x3(diff_mod_out_phase_buff[i], qpsk_sym1to3(tmp));
			//y.data = (ap_uint<6>) (((ap_uint<3>) diff_mod_out_phase_buff[i].imag) << 3 | ((ap_uint<3>) diff_mod_out_phase_buff[i].real));
#endif
			y.last = (i==1535) ? 1 : 0;
			output.write(y);
    	}
    }
}
